﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace valasztas
{
    struct Candidate
    {
        public int AreaCode, Vote;
        public string Fname, Sname, Part;
        public string Name()
        {
            return Fname + " " + Sname;
        }

        public Candidate(string[] adat)
        {
            AreaCode = int.Parse(adat[0]);
            Vote = int.Parse(adat[1]);
            Fname = adat[2];
            Sname = adat[3];
            Part = adat[4] == "-" ? "Független" : adat[4];
        }
    }

    class Program
    {
        enum Part { GYEP, HEP, TISZ, ZEP, Független };

        static Candidate[] candidates = new Candidate[100];
        static int cdb = 0;

        static void Main(string[] args)
        {
            #region 1. feladat - Adatbeolvasás
            Console.WriteLine("\n1. feladat");
            using (System.IO.StreamReader reader = new System.IO.StreamReader("szavazatok.txt"))
            {
                while (!reader.EndOfStream)
                {
                    candidates[cdb] = new Candidate(reader.ReadLine().Split(' '));
                    cdb++;
                }
            }
            #endregion

            #region 2. feladat - Rekordok száma
            Console.WriteLine("\n2. feladat");
            Console.WriteLine("A helyhatósági választáson {0} képviselőjelölt indult.", cdb);
            #endregion

            #region 3. feladat - Egy képviselő adata
            Console.WriteLine("\n3. feladat");
            Console.Write("Adja meg a képviselő vezeték és keresztnevét szóközzel elválasztva: ");
            string name = Console.ReadLine();
            int i;
            for (i = 0; i < cdb; i++)
            {
                if (name == candidates[i].Name())
                {
                    Console.WriteLine("A képviselő {0} szavazatot kapott.", candidates[i].Vote);
                    break;
                }
            }
            if (i == cdb)
            {
                Console.WriteLine("Ilyen nevű képviselőjelölt nem szerepel a nyilvántartásban!");
            }
            #endregion

            #region 4. feladat - Szavazási arány
            Console.WriteLine("\n4. feladat");
            int szum = 0;
            foreach (Candidate c in candidates)
            {
                szum += c.Vote;
            }
            Console.WriteLine("A választáson {0} állampolgár, a jogosultak {1}-a vett részt.", szum, ((szum * 1.0) / 12345).ToString(".00%"));
            #endregion

            #region 5. feladat - Pártonkénti eredmény
            Console.WriteLine("\n5. feladat");
            int[] arany = new int[5];
            string[] hosszunev = new string[5];
            hosszunev[(int)Part.GYEP] = "Gyümölcsevők Pártja";
            hosszunev[(int)Part.HEP] = "Húsevők Pártja";
            hosszunev[(int)Part.TISZ] = "Tejivók Szövetsége";
            hosszunev[(int)Part.ZEP] = "Zöldségevők Pártja";
            hosszunev[(int)Part.Független] = "Független jelöltek";



            for (i = 0; i < cdb; i++)
            {
                arany[(int)Enum.Parse(typeof(Part), candidates[i].Part)] += candidates[i].Vote;
            }

            for (i = 0; i < hosszunev.Length; i++)
            {
                Console.WriteLine("{0,-20}: {1,5:P2}", hosszunev[i], arany[i] * 1.0 / szum);
            }
            #endregion

            #region 6. feladat - Legjobbak
            Console.WriteLine("\n6. feladat");
            int max = candidates[0].Vote;
            for (i = 1; i < cdb; i++)
            {
                if (candidates[i].Vote > max)
                {
                    max = candidates[i].Vote;
                }
            }
            for (i = 0; i < cdb; i++)
            {
                if (candidates[i].Vote == max)
                {
                    Console.WriteLine("\t{0} - {1}",candidates[i].Name(), candidates[i].Part);
                }
            }
            #endregion

            #region 7. feladat - Választási eredmény kiírása
            Console.WriteLine("\n7. feladat");
            int[] localMax = new int[9];
            string[] winner = new string[9];
            for (int j = 0; j < 9; j++)
            {
                localMax[j] = 0;
            }
            for (i = 0; i < cdb; i++)
            {
                if (candidates[i].Vote > localMax[candidates[i].AreaCode])
                {
                    localMax[candidates[i].AreaCode] = candidates[i].Vote;
                    winner[candidates[i].AreaCode] = String.Format("{0} {1}", candidates[i].Name(), candidates[i].Part);
                }
            }
            using (System.IO.StreamWriter writer = new System.IO.StreamWriter("kepviselok.txt"))
            {
                foreach (string w in winner)
                {
                    writer.WriteLine(w);
                    //Console.WriteLine(w);
                }
                Console.WriteLine("Kész");
            }

            #endregion
            Console.ReadLine();
        }
    }
}
