
-- --------------------------------------------------
-- Entity Designer DDL Script for SQL Server 2005, 2008, and Azure
-- --------------------------------------------------
-- Date Created: 07/19/2013 16:32:06
-- Generated from EDMX file: D:\Sztzs\Desktop\progtáborhoz\Érettségi\valasztas_4EF\valasztas\Model1.edmx
-- --------------------------------------------------

SET QUOTED_IDENTIFIER OFF;
GO
USE [valasztas];
GO
IF SCHEMA_ID(N'dbo') IS NULL EXECUTE(N'CREATE SCHEMA [dbo]');
GO

-- --------------------------------------------------
-- Dropping existing FOREIGN KEY constraints
-- --------------------------------------------------

IF OBJECT_ID(N'[dbo].[FK_PartCandidate]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[CandidateSet] DROP CONSTRAINT [FK_PartCandidate];
GO

-- --------------------------------------------------
-- Dropping existing tables
-- --------------------------------------------------

IF OBJECT_ID(N'[dbo].[PartSet]', 'U') IS NOT NULL
    DROP TABLE [dbo].[PartSet];
GO
IF OBJECT_ID(N'[dbo].[CandidateSet]', 'U') IS NOT NULL
    DROP TABLE [dbo].[CandidateSet];
GO

-- --------------------------------------------------
-- Creating all tables
-- --------------------------------------------------

-- Creating table 'PartSet'
CREATE TABLE [dbo].[PartSet] (
    [Short] nvarchar(20)  NOT NULL,
    [Long] nvarchar(max)  NOT NULL
);
GO

-- Creating table 'CandidateSet'
CREATE TABLE [dbo].[CandidateSet] (
    [Id] int IDENTITY(1,1) NOT NULL,
    [AreaCode] int  NOT NULL,
    [Vote] int  NOT NULL,
    [Fname] nvarchar(max)  NOT NULL,
    [Sname] nvarchar(max)  NOT NULL,
    [PartShort] nvarchar(20)  NOT NULL
);
GO

-- --------------------------------------------------
-- Creating all PRIMARY KEY constraints
-- --------------------------------------------------

-- Creating primary key on [Short] in table 'PartSet'
ALTER TABLE [dbo].[PartSet]
ADD CONSTRAINT [PK_PartSet]
    PRIMARY KEY CLUSTERED ([Short] ASC);
GO

-- Creating primary key on [Id] in table 'CandidateSet'
ALTER TABLE [dbo].[CandidateSet]
ADD CONSTRAINT [PK_CandidateSet]
    PRIMARY KEY CLUSTERED ([Id] ASC);
GO

-- --------------------------------------------------
-- Creating all FOREIGN KEY constraints
-- --------------------------------------------------

-- Creating foreign key on [PartShort] in table 'CandidateSet'
ALTER TABLE [dbo].[CandidateSet]
ADD CONSTRAINT [FK_PartCandidate]
    FOREIGN KEY ([PartShort])
    REFERENCES [dbo].[PartSet]
        ([Short])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_PartCandidate'
CREATE INDEX [IX_FK_PartCandidate]
ON [dbo].[CandidateSet]
    ([PartShort]);
GO

-- --------------------------------------------------
-- Script has ended
-- --------------------------------------------------