﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace valasztas
{
    public partial class Valasztas : Form
    {
        public Valasztas()
        {
            InitializeComponent();
        }

        const int Total = 12345;
        List<Candidate> candidates = new List<Candidate>();

        private void Form1_Load(object sender, EventArgs e)
        {
            //1. feladat
            using (System.IO.StreamReader reader = new System.IO.StreamReader("szavazatok.txt"))
            {
                while (!reader.EndOfStream)
                {
                    candidates.Add(new Candidate(reader.ReadLine().Split(' ')));
                }

            }
            
            //2. feladat
            int n = candidates.Count;
            if (MessageBox.Show("Az adatok beolvasása kész.", "1.feladat") == DialogResult.OK)
            {
                MessageBox.Show(String.Format("A helyhatósági választáson {0} képviselőjelölt indult.",n), "2. feladat");
            }

            //4. feladat
            lbl04.Text = String.Format("4. feladat:\nA választáson {0} állampolgár, a jogosultak {1:P2}-a vett részt.", VoteSum(), 1.0 * VoteSum() / Total);

            //5. feladat
            GYEP.Text = String.Format("{0:P2}", candidates.Sum(c => c.Part == "GYEP" ? c.Vote * 1.0 / VoteSum() : 0));
            HEP.Text = String.Format("{0:P2}", candidates.Sum(c => c.Part == "HEP" ? c.Vote * 1.0 / VoteSum() : 0));
            TISZ.Text = String.Format("{0:P2}", candidates.Sum(c => c.Part == "TISZ" ? c.Vote * 1.0 / VoteSum() : 0));
            ZEP.Text = String.Format("{0:P2}", candidates.Sum(c => c.Part == "ZEP" ? c.Vote * 1.0 / VoteSum() : 0));
            Független.Text = String.Format("{0:P2}", candidates.Sum(c => c.Part == "Független" ? c.Vote * 1.0 / VoteSum() : 0));

            //6. feladat
            int max = -1;
            foreach (Candidate c in candidates)
            {
                if (c.Vote > max)
                {
                    max = c.Vote;
                }
            }
            foreach (Candidate c in candidates)
            {
                if (c.Vote == max)
                {
                    lst06.Items.Add(String.Format("{0} - {1}", c.Name(), c.Part));
                }
            }

            //7. feladat
            using (System.IO.StreamWriter writer = new System.IO.StreamWriter("kepviselok.txt"))
            {
                foreach (string s in Feladat07())
                {
                    writer.WriteLine(s);
                }
            }
            lbl07.Text += ": Kész";
        }

        //3. feladat
        private void Feladat03(object sender, EventArgs e)
        {
            try
            {
                int p = 0;
                while (candidates[p].Name() != txtFname.Text + " " + txtSname.Text)
                {
                    p++;
                }
                MessageBox.Show(String.Format("{0} képviselő {1} szavazatot kapott", candidates[p].Name(), candidates[p].Vote), "3. feladat");
            }
            catch 
            {
                MessageBox.Show("Ilyen nevű képviselőjelölt nem szerepel a nyilvántartásban!", "3. feladat");
            }
        }

        //4. feladathoz
        private int VoteSum()
        {
            int sum = 0;
            foreach (Candidate c in candidates)
            {
                sum += c.Vote;
            }
            return sum;
        }

        //7. feladathoz
        private string[] Feladat07()
        {
            int[] localMax = new int[9];
            string[] winner = new string[9];
            for (int i = 0; i < 9; i++)
            {
                localMax[i] = 0;
            }
            foreach (Candidate c in candidates)
            {
                if (c.Vote > localMax[c.AreaCode])
                {
                    localMax[c.AreaCode] = c.Vote;
                    winner[c.AreaCode] = String.Format("{0} {1}", c.Name(), c.Part);
                }
            }

            return winner;
        }
    }
}
